#!/bin/bash
#
# Copyright (c) Semarchy.  All rights reserved.
#
# PRODUCT Semarchy xDI Runtime
#   
#	This script allows to stop a Runtime.
#
#	Note:
#	To have an overview of the possible parameters, use the -usage parameter
#	
#	Examples:
#	stopengine.sh -usage
#	stopengine.sh -port 42200
#

sp0=$( cd "$(dirname "${BASH_SOURCE[0]}")" ; pwd -P )

. "$sp0/initvariables.sh"

if [ "$STAMBIA_JAVA_HOME" = "" ]; then
        if [ "$JAVA_HOME" = "" ]; then
	        java "${XDI_RUNTIME_VM_PROPERTIES[@]}" "$XDI_RUNTIME_STARTENGINE_VM_PROPERTIES" "$XDI_RUNTIME_SYSTEM_CLASSLOADER" "$XDI_RUNTIME_INIT_CLASSPATH_OPTION" "$XDI_RUNTIME_CORE_CLASSPATH_OPTION" "$XDI_RUNTIME_MODULES_PATH_OPTION" -Dstambia.classpath.v1.root="$XDI_RUNTIME_CLASSPATH_FOLDER1" -classpath "$XDI_RUNTIME_CLASSPATH" com.indy.engine.launcher.MainLauncher -mainclass com.indy.engine.command.EngineStopI -conf "$XDI_RUNTIME_CONF_FILE_LOCATION" "$@"
        else
                "$JAVA_HOME/bin/java" "${XDI_RUNTIME_VM_PROPERTIES[@]}" "$XDI_RUNTIME_STARTENGINE_VM_PROPERTIES" "$XDI_RUNTIME_SYSTEM_CLASSLOADER" "$XDI_RUNTIME_INIT_CLASSPATH_OPTION" "$XDI_RUNTIME_CORE_CLASSPATH_OPTION" "$XDI_RUNTIME_MODULES_PATH_OPTION" -Dstambia.classpath.v1.root="$XDI_RUNTIME_CLASSPATH_FOLDER1" -classpath "$XDI_RUNTIME_CLASSPATH" com.indy.engine.launcher.MainLauncher -mainclass com.indy.engine.command.EngineStopI -conf "$XDI_RUNTIME_CONF_FILE_LOCATION" "$@"
        fi
else
	"$STAMBIA_JAVA_HOME/bin/java" "${XDI_RUNTIME_VM_PROPERTIES[@]}" "$XDI_RUNTIME_STARTENGINE_VM_PROPERTIES" "$XDI_RUNTIME_SYSTEM_CLASSLOADER" "$XDI_RUNTIME_INIT_CLASSPATH_OPTION" "$XDI_RUNTIME_CORE_CLASSPATH_OPTION" "$XDI_RUNTIME_MODULES_PATH_OPTION" -Dstambia.classpath.v1.root="$XDI_RUNTIME_CLASSPATH_FOLDER1" -classpath "$XDI_RUNTIME_CLASSPATH" com.indy.engine.launcher.MainLauncher -mainclass com.indy.engine.command.EngineStopI -conf "$XDI_RUNTIME_CONF_FILE_LOCATION" "$@"
fi

